@echo off
:: ---------------------------------------------------------------------------
:: Parameter:
::		%1 = Destination Verzeichnis
::		%2 = optional: Source Verzeichnis
::		%3 = optional: Type: Tag Monat oder Taste (aus GUI) 
::
::	Wenn keine argumente übergeben werden, dann werden Default Werte angenommen
:: ---------------------------------------------------------------------------
:: Destination Path

if "%~1"=="" goto e1
	set BakDir=%~1
	if "%BakDir:~-1,1%"=="\" set BakDir=%BakDir:~0,-1%
	goto endif1
:else1
	set BakDir=c:\KassaBackup
	if exist d:\ set BakDir=d:\KassaBackup
	if exist e:\ set BakDir=e:\KassaBackup
:endif1
	set DelDir=%BakDir%
	
:: ----------------------------------------------------------------------------
::	Tag Monat Jahr aus aktuellem Datum ermitteln
:: https://stackoverflow.com/questions/3472631/how-do-i-get-the-day-month-and-year-from-a-windows-cmd-exe-script

for /F "skip=1 delims=" %%F in ('
    wmic PATH Win32_LocalTime GET Day^,Month^,Year /FORMAT:TABLE
') do (
    for /F "tokens=1-3" %%L in ("%%F") do (
        set CurrDay=0%%L
        set CurrMonth=0%%M
        set CurrYear=%%N
    )
)
set CurrDay=%CurrDay:~-2%
set CurrMonth=%CurrMonth:~-2%

:: ---------------------------------------------------------------------------
:: Destination Path zusammenstellen und eventuell erstellen

set current=%CurrYear%%CurrMonth%%CurrDay%
set BakDir=%BakDir%\%CurrYear%\%CurrMonth%
if not exist "%BakDir%" md "%BakDir%"

@echo Sicherung nach: %BakDir%\%current%.ZIP

:: ===========================================================================
:: Source Path
:: Default Verzeichnis ist das eigene Verzeichnis, wo die ZipBackup.cmd liegt

set SourceDir=%~dp0

:: ---------------------------------------------------------------------------
:: Prüfe ob ein Source Parameter übergeben wurde

set ZweiLeer=0
if "%~2"=="" set ZweiLeer=1
if "%~2"=="Tag" set ZweiLeer=2
if "%~2"=="Monat" set ZweiLeer=3
if "%~2"=="Taste" set ZweiLeer=3
if "%~2"=="TasteTag" set ZweiLeer=2
if "%~2"=="TasteMon" set ZweiLeer=3

if not %ZweiLeer%==0 goto endif2
	set SourceDir=%~2
:endif2
if "%SourceDir:~-1,1%"=="\" set SourceDir=%SourceDir:~0,-1%

@echo Sicherung aus:  %SourceDir%

:: ---------------------------------------------------------------------------
:: Teste ob eine Monatssicherung vorliegt

if "%~3"=="Taste" set ZweiLeer=3
if "%~3"=="Monat" set ZweiLeer=3
if "%~3"=="TasteMon" set ZweiLeer=3

if not %ZweiLeer%==3 goto endif3

:: ------------------------------------------------
:: Loop

echo Alte Daten loeschen:

set YearCnt=2
:beginloop
if %YearCnt% GTR 10 goto endloop 
 
set /A OldYear=%CurrYear%-%YearCnt%
set del=%DelDir%\%OldYear%
if exist "%del%" echo loesche: %del%
if exist "%del%" rd "%del%" /s /q

set /A YearCnt=%YearCnt%+1
goto beginloop
:endloop
:endif3

:: ---------------------------------------------------------------------------
:: Daten mit 7-Zip komprimieren

echo Daten sichern:
"%~dp07za.exe" u -tzip -r -y -bso0 -bse1 -bsp1 "%BakDir%\%current%.ZIP" "%SourceDir%"

echo Fertig
:: @pause
